Index: django/db/models/base.py
===================================================================
--- django/db/models/base.py	(revision 11476)
+++ django/db/models/base.py	(working copy)
@@ -231,8 +231,10 @@
         if cls.__doc__ is None:
             cls.__doc__ = "%s(%s)" % (cls.__name__, ", ".join([f.attname for f in opts.fields]))
 
-        if hasattr(cls, 'get_absolute_url'):
-            cls.get_absolute_url = curry(get_absolute_url, opts, cls.get_absolute_url)
+        app_label_model_name = '%s.%s' % (opts.app_label, opts.module_name)
+        get_absolute_url_override = settings.ABSOLUTE_URL_OVERRIDES.get(app_label_model_name)
+        if get_absolute_url_override:
+            setattr(cls, 'get_absolute_url', get_absolute_url_override)
 
         signals.class_prepared.send(sender=cls)
 
@@ -631,14 +633,6 @@
             ordered_obj.objects.filter(**{order_name: rel_val}).values(pk_name)]
 
 
-##############################################
-# HELPER FUNCTIONS (CURRIED MODEL FUNCTIONS) #
-##############################################
-
-def get_absolute_url(opts, func, self, *args, **kwargs):
-    return settings.ABSOLUTE_URL_OVERRIDES.get('%s.%s' % (opts.app_label, opts.module_name), func)(self, *args, **kwargs)
-
-
 ########
 # MISC #
 ########
Index: tests/modeltests/url_overrides/__init__.py
===================================================================
Index: tests/modeltests/url_overrides/tests.py
===================================================================
--- tests/modeltests/url_overrides/tests.py	(revision 0)
+++ tests/modeltests/url_overrides/tests.py	(revision 0)
@@ -0,0 +1,50 @@
+from new import classobj
+from unittest import TestCase
+
+from django.conf import settings
+from django.db import models
+
+class AbsoluteUrlOverrideTests(TestCase):
+    """
+    Tests for inserting or overriding model class get_absolute_url methods with 
+    ABSOLUTE_URL_OVERRIDES -setting. 
+    """
+    def setUp(self):
+        super(AbsoluteUrlOverrideTests, self).setUp()
+        self.old_overrides = settings.ABSOLUTE_URL_OVERRIDES
+        settings.ABSOLUTE_URL_OVERRIDES = {}
+
+    def tearDown(self):
+        super(AbsoluteUrlOverrideTests, self).tearDown()
+        settings.ABSOLUTE_URL_OVERRIDES = self.old_overrides
+        
+    def test_insert_method(self):
+        klass_one = self._create_model_class('TestModelOne')
+        self.assertFalse(hasattr(klass_one, 'get_absolute_url'))
+        
+        settings.ABSOLUTE_URL_OVERRIDES['url_overrides.testmodeltwo'] = lambda o: '/%s/' % o.name
+        
+        klass_two = self._create_model_class('TestModelTwo')
+        self.assertTrue(hasattr(klass_two, 'get_absolute_url'))
+        name = 'Rose'
+        self.assertEquals('/%s/' % name, klass_two(name=name).get_absolute_url())
+    
+    def test_override_method(self):
+        class_method = lambda o: 'class_method'
+        klass_one = self._create_model_class('TestModelUno', class_method)
+        name = 'Rose'
+        self.assertTrue(hasattr(klass_one, 'get_absolute_url'))
+        self.assertEqual('class_method', klass_one(name=name).get_absolute_url())
+        
+        settings.ABSOLUTE_URL_OVERRIDES['url_overrides.testmodeldos'] = lambda o: '/%s/' % o.name
+        
+        klass_two = self._create_model_class('TestModelDos', class_method)
+        self.assertEquals('/%s/' % name, klass_two(name=name).get_absolute_url())
+        
+    
+    def _create_model_class(self, class_name, get_absolute_url_method=None):
+        members = {'name': models.CharField(max_length=50)}
+        if get_absolute_url_method:
+            members['get_absolute_url'] = get_absolute_url_method
+        
+        return classobj(class_name, (models.Model,), members)
\ No newline at end of file
Index: tests/modeltests/url_overrides/models.py
===================================================================
Index: docs/ref/settings.txt
===================================================================
--- docs/ref/settings.txt	(revision 11476)
+++ docs/ref/settings.txt	(working copy)
@@ -14,7 +14,7 @@
 Default: ``{}`` (Empty dictionary)
 
 A dictionary mapping ``"app_label.model_name"`` strings to functions that take
-a model object and return its URL. This is a way of overriding
+a model object and return its URL. This is a way of inserting or overriding
 ``get_absolute_url()`` methods on a per-installation basis. Example::
 
     ABSOLUTE_URL_OVERRIDES = {